#ifndef __CUI_H__
#define __CUI_H__

typedef struct cui_base *cui;

struct cui_base{
	cui parent, children, next;
	int x, y, w, h;
};	

typedef struct cui_panel{
	struct cui_base base;
} *cui_panel;

typedef struct cui_label{
	struct cui_base base;
	char *s;
} *cui_label;

typedef struct cui_button{
	struct cui_label label;
} *cui_button;

cui cui_alloc(int size);
void cui_base_init(cui obj, cui parent, int x, int y, int w, int h);
void cui_base_child_add(cui obj, cui child);
cui cui_panel_new(cui parent, int x, int y, int w, int h);
void cui_panel_init(cui obj, cui parent, int x, int y, int w, int h);
cui cui_label_new(cui parent, int x, int y, char *s);
void cui_label_init(cui obj, cui parent, int x, int y, char *s);
cui cui_button_new(cui parent, int x, int y, char *s);
void cui_button_init(cui obj, cui parent, int x, int y, char *s);

#endif
